-- by mor2000

PlaceableUPK = {}
PlaceableUPK_mt = Class(PlaceableUPK, Placeable)

InitObjectClass(PlaceableUPK, "PlaceableUPK")

function PlaceableUPK:new(isServer, isClient, customMt)
	local mt = customMt
	if mt == nil then
		mt = PlaceableUPK_mt
	end
	local self = Placeable:new(isServer, isClient, mt)
	registerObjectClassName(self, "PlaceableUPK")
	self.isServer=isServer
	self.isClient=isClient
	return self
end

function PlaceableUPK:load(xmlFilename, x, y, z, rx, ry, rz, moveMode, initRandom)
    if not PlaceableUPK:superClass().load(self, xmlFilename, x, y, z, rx, ry, rz, moveMode, initRandom) then
		return false
    end

	if not moveMode and self.nodeId~=nil then
		self.base=UPK_Base:new(g_server ~= nil, g_client ~= nil)
		self.base:load(self.nodeId)
	end -- not moveMode

	return true
end

function PlaceableUPK:delete()
	if self.base~=nil then
		self.base:delete(self.base)
	end
	PlaceableUPK:superClass().delete(self)
end

function PlaceableUPK:loadFromAttributesAndNodes(xmlFile, key)
	if not PlaceableUPK:superClass().loadFromAttributesAndNodes(self, xmlFile, key, resetVehicles) then
		return false
	end
	
	if self.base~=nil then
		self.base:loadFromAttributesAndNodes(xmlFile, key)
	end
	
	return true
end

function PlaceableUPK:getSaveAttributesAndNodes(nodeIdent)
	local attributes, nodes = PlaceableUPK:superClass().getSaveAttributesAndNodes(self, nodeIdent)

	if self.base~=nil then
		local baseAttributes, baseNodes=self.base:getSaveAttributesAndNodes(nodeIdent)
		attributes=attributes .. baseAttributes
		nodes=nodes .. baseNodes
	end
	
	return attributes, nodes
end